<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourImComplaintTypeRef"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourImComplaintType()" @reset="resetFormTourImComplaintType">
        <el-form-item label="类型名称">
          <el-input
            class="filter-item"
            v-model="formFilter.typeNameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="是否启用">
          <el-select
            class="filter-item"
            v-model="formFilter.enableFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="enableFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in enableFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourImComplaintTypeTable"
      class="page-table"
      :data="formTourImComplaintTypeTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourImComplaintTypeTableWidgetCurrentPage - 1) * formTourImComplaintTypeTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourImComplaintTypeTableWidget.onSortChange"
      @refresh="formTourImComplaintTypeTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:addTourImComplaintType')"
          @click="onAddTourImComplaintTypeClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:exportTourImComplaintType')"
          @click="onExportTourImComplaintTypeClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:importTourImComplaintType')"
          :on-change="onImportTourImComplaintTypeClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
              :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:importTourImComplaintType')"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourImComplaintTypeTableWidget.getTableIndex" :width="80" />
      <vxe-column title="类型名称" field="typeName" />
      <vxe-column title="类型描述" field="description" />
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourImComplaintTypeClick(scope.row)"
            :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:editTourImComplaintType')"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourImComplaintTypeClick(scope.row)"
            :disabled="!checkPermCodeExist('formTourImComplaintType:formTourImComplaintType:deleteTourImComplaintType')"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourImComplaintTypeTableWidgetTotalCount"
            :current-page="formTourImComplaintTypeTableWidgetCurrentPage"
            :page-size="formTourImComplaintTypeTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourImComplaintTypeTableWidget.onCurrentPageChange"
            @size-change="formTourImComplaintTypeTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourImComplaintType',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourImComplaintTypeData } from '@/api/generated/tourImComplaintTypeController';
import { TourImComplaintTypeController } from '@/api/generated';
import FormEditTourImComplaintType from '@/pages/ImComplaint/formEditTourImComplaintType.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 类型名称
  typeNameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});
const formFilterCopy = reactive({
  // 类型名称
  typeNameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});

const onCancel = () => {
  router.go(-1);
  layoutStore.removeCachePage(route.fullPath as string);
  route.meta.refreshParentCachedPage = true;
};

const onResume = () => {
  refreshFormTourImComplaintType();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourImComplaintTypeTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourImComplaintTypeDtoFilter: {
      typeName: formFilter.typeNameFilter,
      enable: formFilter.enableFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourImComplaintTypeController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourImComplaintTypeTableVerify = () => {
  formFilterCopy.typeNameFilter = formFilter.typeNameFilter;
  formFilterCopy.enableFilter = formFilter.enableFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourImComplaintTypeClick = (row?: TourImComplaintTypeData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourImComplaintType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourImComplaintTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourImComplaintTypeClick = (row?: TourImComplaintTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourImComplaintType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourImComplaintTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourImComplaintTypeClick = (row?: TourImComplaintTypeData) => {
  let params: ANY_OBJECT = {
  };

  TourImComplaintTypeController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourImComplaintTypeClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourImComplaintTypeController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourImComplaintTypeTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourImComplaintTypeClick = (row?: TourImComplaintTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourImComplaintTypeController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourImComplaintTypeTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourImComplaintTypeTableOptions: TableOptions<TourImComplaintTypeData> = {
  loadTableData: loadFormTourImComplaintTypeTableWidgetData,
  verifyTableParameter: loadFormTourImComplaintTypeTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourImComplaintTypeTable = ref();
const formTourImComplaintTypeTableWidget = useTable(formTourImComplaintTypeTableOptions);
const {
  dataList: formTourImComplaintTypeTableWidgetDataList,
  currentPage: formTourImComplaintTypeTableWidgetCurrentPage,
  pageSize: formTourImComplaintTypeTableWidgetPageSize,
  totalCount: formTourImComplaintTypeTableWidgetTotalCount,
} = formTourImComplaintTypeTableWidget;
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableFilterOptions: DropdownOptions<DictData> = {
  loadData: loadEnableFilterDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableFilterWidget = useDropdown(enableFilterOptions);
const { dropdownList: enableFilterWidgetDropdownList } = enableFilterWidget
const refreshFormTourImComplaintType = () => {
  // 刷新段落
  formTourImComplaintTypeTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourImComplaintType = () => {
  formFilter.typeNameFilter = undefined;
  formFilterCopy.typeNameFilter = undefined;
  formFilter.enableFilter = undefined;
  formFilterCopy.enableFilter = undefined;
  refreshFormTourImComplaintType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourImComplaintType();
};
const formInit = () => {
  enableFilterWidget.onVisibleChange(true).catch(e => {console.error(e)});
  refreshFormTourImComplaintType();
};

onMounted(() => {
  formInit();
});

onActivated(() => {
  onResume();
});
</script>